"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("query-string"),t=require("normalizr"),r=require("reselect"),n=require("redux"),i=require("react"),s=require("hoist-non-react-statics"),o=require("validate.js");function a(e){return e&&"object"==typeof e&&"default"in e?e:{default:e}}var l=a(e),u=a(i),d=a(s),c=a(o);const f={UPSERT:"snowbox/UPSERT",REMOVE:"snowbox/REMOVE",FIND:"snowbox/FIND",FETCH:"snowbox/FETCH",CLEAR:"snowbox/CLEAR",NO_FETCH:"snowbox/NO_FETCH"},y="pending",h="succeeded",p="failed",v={JSON:"snowbox/JSON",FORM_DATA:"snowbox/FORM_DATA"};var E=new class{setBaseUrl(e){if("string"!=typeof e)throw new Error("[Snowbox] Api base url must be string");this.baseUrl=e}setTokenHeaderName(e){if("string"!=typeof e)throw new Error("[Snowbox] Token Header Name must be string");this.tokenHeader=e}setHeaderRequest(e,t){if(this.requestHeaders||(this.requestHeaders={}),"string"!=typeof e)throw new Error("[Snowbox] Request header name must be a string");if("string"!=typeof t)throw new Error("[Snowbox] Request header value must be a string");this.requestHeaders[e]=t}setTokenGetter(e){if("function"!=typeof e)throw new Error("[Snowbox] Token Getter must be function");this.tokenGetter=e}async setAuthToken(e){if(!this.tokenGetter||!this.tokenHeader)return;const t=await this.tokenGetter();t&&e.setRequestHeader(this.tokenHeader,t)}get(e,t){return this.call("GET",e,t)}post(e,t={},r,n){return this.call("POST",e,r,t,n)}put(e,t={},r,n){return this.call("PUT",e,r,t,n)}patch(e,t={},r,n){return this.call("PATCH",e,r,t,n)}remove(e,t={},r){return this.call("DELETE",e,r,t)}async call(e,t,r,n,i=v.JSON){if(!this.baseUrl)throw new Error("[Snowbox] Base API url must be defined");return new Promise((async(s,o)=>{const a=new XMLHttpRequest,u=t.indexOf("?")>-1?"&":"?",d="object"==typeof r?u+l.default.stringify(r):"";let c;switch(a.open(e,`${this.baseUrl}${t}${d}`,!0),a.onload=()=>{if(4!=a.readyState)return!1;let e;try{e=JSON.parse(a.responseText)}catch(t){e=a.responseText}a.status>=200&&a.status<300?s(e.data?e.data:e):o({status:a.status,message:e.message||e})},i){case v.JSON:a.setRequestHeader("Content-type","application/json; charset=utf-8"),n&&(c=JSON.stringify(n));break;case v.FORM_DATA:a.setRequestHeader("Content-type","multipart/form-data"),"object"==typeof n&&(c=new FormData,Object.keys(n).forEach((e=>c.append(e,n[e]))));break;default:return o(new Error(`[Snowbox] Invalid content type "${i}"`))}this.requestHeaders&&0!==Object.keys(this.requestHeaders).length&&Object.keys(this.requestHeaders).forEach((e=>{a.setRequestHeader(e,this.requestHeaders[e])})),await this.setAuthToken(a),a.send(n?c:void 0)}))}};const b=e=>`${e}_SUCCESS`,w=e=>`${e}_FAILURE`,m=e=>(t={})=>({type:e,...t}),g=e=>t=>(r,n,i,s)=>({type:b(e),entity:t,data:r,entities:n,result:i,date:s}),T=e=>t=>(r,n,i)=>({type:w(e),entity:t,data:r,error:n,statusCode:i}),S=e=>t=>(r,n={})=>({type:e,entity:t,data:r,options:n,success:g(e)(t),failure:T(e)(t)}),x=S(f.UPSERT),k=S(f.REMOVE),F=S(f.FIND),R=S(f.FETCH),A=m(f.CLEAR),H=m(f.NO_FETCH),O=(e={})=>!e||"object"!=typeof e||Array.isArray(e)?"#":Object.keys(e).sort().reduce(((t,r)=>t+=`${r}[${e[r]}]`),"#"),C=e=>e.snowbox,P=r.createSelector(C,(e=>e.meta)),D=r.createSelector(C,(e=>e.entities)),q=r.createSelector(C,(e=>e.singletons)),U=(e,t=0)=>r=>n=>{if(!n||!t)return n;if(Array.isArray(n))return n.map((n=>U(e,t)(r)(n)));const i={...n};for(const s in e.schema){const o=Array.isArray(e.schema[s])?e.schema[s][0]:e.schema[s];i[s]=U(o,t-1)(r)(Array.isArray(n[s])?n[s].map((e=>r[o.key][e])):r[o.key][n[s]])}return i},V=[],N=[f.FETCH,b(f.FETCH),w(f.FETCH),f.FIND,b(f.FIND),w(f.FIND),f.UPSERT,b(f.UPSERT),w(f.UPSERT),f.REMOVE,b(f.REMOVE),w(f.REMOVE)],_=(e={},t)=>{switch(t.type){case f.FETCH:return{progress:y};case b(f.FETCH):return{progress:h,result:t.result,__updatedAt:t.date};case w(f.FETCH):return{progress:p,error:t.error}}},M=(e={},t)=>{const r=O(t.data);return{...e,[r]:_(e[r],t)}},$=n.combineReducers({entities:(e={},t)=>{var r;if(!N.includes(t.type))return e;if(null!=t&&null!==(r=t.entity)&&void 0!==r&&r.singleton)return e;if(t.type==b(f.REMOVE)){const r={...e,[t.entity.key]:{...e[t.entity.key]}},n="number"==typeof t.data?t.data:t.data[t.entity.idAttribute];return delete r[t.entity.key][n],r}if(!t.entities)return e;const n={...e};for(const e in t.entities){n[e]={...n[e]||{}};for(const r in t.entities[e])n[e][r]={...(n[e]||{})[r]||{},...t.entities[e][r],__updatedAt:t.date}}return n},meta:(e={},t)=>{if(![f.FETCH,b(f.FETCH),w(f.FETCH)].includes(t.type))return e;const r=Array.isArray(t.entity)?t.entity[0]:t.entity;return r.singleton?e:{...e,[r.key]:M(e[r.key],t)}},singletons:(e={},t)=>{var r;if(!N.includes(t.type))return e;if(null==t||null===(r=t.entity)||void 0===r||!r.singleton)return e;const n={...e};return t.type==b(f.REMOVE)?(delete n[t.entity.key],n):(n[t.entity.key]={...t.result,__updatedAt:t.date},n)}}),j={[f.UPSERT]:"upsert",[f.REMOVE]:"remove",[f.FIND]:"fetch",[f.FETCH]:"fetch"},I=e=>(t={},r)=>{const n={valid:!0,touched:!1,error:null,submitted:!1,fields:{},initialValues:{}},i=r||t;return e.forEach((e=>{n.initialValues[e]=void 0===i[e]?null:i[e],n.fields[e]={valid:!0,dirty:!1,touched:!1,error:null,value:n.initialValues[e]}})),n},J=(e,t,r)=>n=>i=>{const s=e.reduce(((e,t)=>e.fields[t].dirty&&!r||void 0===(null==n?void 0:n[t])||null===(null==n?void 0:n[t])?e:{...e,fields:{...e.fields,[t]:{...e.fields[t],value:n[t],dirty:!1}},initialValues:{...e.initialValues,[t]:n[t]}}),i);return B(e,t)(s)},L=e=>t=>e.reduce(((e,r)=>({...e,[r]:t.fields[r].value})),{}),B=(e,t)=>r=>{const n=c.default(L(e)(r),t);let i=!0;return e.forEach((e=>{const t=n&&n[e]?n[e][0]:null;i=i&&!t,r={...r,valid:i,fields:{...r.fields,[e]:{...r.fields[e],error:t,valid:!t}}}})),r},G=(e,t)=>(r,n,i)=>{var s;if(!e.includes(n))throw new Error(`[Snowbox Form] Unknown field: ${n}`);let o={...r,fields:{...r.fields,[n]:{...r.fields[n],value:i,dirty:(null==r||null===(s=r.initialValues)||void 0===s?void 0:s[n])!==i}}};return B(e,t)(o)},z=e=>(t,r)=>{if(!e.includes(r))throw new Error(`[Snowbox Form] Unknown field: ${r}`);return{...t,touched:!0,fields:{...t.fields,[r]:{...t.fields[r],touched:!0}}}},X=e=>(t,r)=>{const n=e.reduce(((e,t)=>({...e,valid:e.valid&&!r[t],submitted:!1,fields:{...e.fields,[t]:{...e.fields[t],error:r[t]||null,valid:!r[t]}}})),t);return r._error&&(n.error=r._error,n.valid=!1),n},K=e=>t=>{const r=e.reduce(((e,t)=>({...e,fields:{...e.fields,[t]:{...e.fields[t],touched:!0}}})),t);return r.valid&&(r.submitted=!0),r};exports.Provider=class{constructor(e){this.particleDefinition=e}fetch(e){const t=this.getFetchPath(e),r=this.getFetchParams(e);return E.get(t,r)}upsert(e,t){const r=this.getUpsertPath(e),n=this.getUpsertMethod(e);return E[n](r,e,t,this.getUpsertContentType())}remove(e,t){const r=this.getRemovePath(e);return E.remove(r,e,t)}getParticle(e){return"function"==typeof this.particleDefinition?this.particleDefinition(e):this.particleDefinition}getFetchPath(e){const t=this.getParticle(e);return e&&"object"!=typeof e?`/${t}/${e}`:`/${t}`}getFetchParams(e){return"object"==typeof e?e:null}getUpsertPath(e){const t=this.getParticle(e);return e.id?`/${t}/${e.id}`:`/${t}`}getUpsertMethod(e){return e.id?"put":"post"}getRemovePath(e){const t=this.getParticle(e);return e.id?`/${t}/${e.id}`:`/${t}`}getUpsertContentType(){return v.JSON}},exports.actions=f,exports.api=E,exports.clearAll=A,exports.contentTypes=v,exports.entity=(e,r,n={},i={})=>{const s=new t.schema.Entity(e,n,i);if(r){if("object"!=typeof r&&"Provider"!=r.constructor.name)throw new Error("[Snowbox] Invalid provider");s.provider=r}return"number"==typeof i.staleTimeout&&(s.staleTimeout=i.staleTimeout),!0===i.singleton&&(s.singleton=!0),s},exports.fetch=R,exports.find=F,exports.remove=k,exports.selectMany=(e,t=0)=>n=>{const i=U(e,t);return r.createSelector(D,P,((t,r)=>{if(!t[e.key])return V;const s=O(n),o=r[e.key]?r[e.key][s]:null;if(!o||!o.result)return i(t)(Object.values(t[e.key]));const a=o.result.map((r=>t[e.key][r]));return i(t)(a)}))},exports.selectOne=(e,t=0)=>n=>{if(e.singleton)return r.createSelector(q,(t=>t[e.key]));const i=U(e,t);return r.createSelector(D,(t=>t[e.key]?i(t)(t[e.key][n]):null))},exports.snowboxMiddleware=e=>r=>async n=>{if(![f.UPSERT,f.REMOVE,f.FIND,f.FETCH].includes(n.type))return r(n);const i=j[n.type],s=Array.isArray(n.entity)?n.entity[0]:n.entity;if("fetch"==i&&!((e,t,r)=>{var n,i;if(!t.staleTimeout)return!0;if(null!=r&&null!==(n=r.options)&&void 0!==n&&n.refresh)return!0;let s;if(Array.isArray(r.entity)){var o,a,l;const n=O(r.data);s=null==e||null===(o=e.snowbox)||void 0===o||null===(a=o.meta)||void 0===a||null===(l=a[t.key])||void 0===l?void 0:l[n]}else if(t.singleton){var u,d;s=null==e||null===(u=e.snowbox)||void 0===u||null===(d=u.singletons)||void 0===d?void 0:d[t.key]}else{var c,f,y;const n=r.data[t.idAttribute];s=null==e||null===(c=e.snowbox)||void 0===c||null===(f=c.entities)||void 0===f||null===(y=f[t.key])||void 0===y?void 0:y[n]}return null===(i=s)||void 0===i||!i.__updatedAt||Date.now()-s.__updatedAt>t.staleTimeout})(e.getState(),s,n))return r(H());r(n);try{const e=await s.provider[i](n.data);if("remove"==i)return r(n.success(n.data));if(s.singleton)return r(n.success(n.data,void 0,e,Date.now()));const{entities:o,result:a}=t.normalize(e,n.entity);return r(n.success(n.data,o,a,Date.now()))}catch(e){return r(n.failure(n.data,e,e.status))}},exports.snowboxReducer=(e,t)=>t.type==f.CLEAR?$(void 0,t):$(e,t),exports.upsert=x,exports.withForm=({fields:e,submitForm:t,initialValues:r={},enableReinitializeDirty:n=!1})=>s=>{const o=((e,t,r)=>({buildInitialState:I(e),handleNewInitialValues:J(e,t,r),getData:L(e),validate:B(e,t),handleChange:G(e,t),handleBlur:z(e),handleServerErrors:X(e),handleSubmit:K(e)}))(Object.keys(e),e,n);return d.default(((e={})=>{const[n,a]=i.useState(o.buildInitialState(r,e.initialValues));i.useEffect((()=>{a((e=>o.validate(e)))}),[]),i.useEffect((()=>{a(o.handleNewInitialValues(e.initialValues))}),[e.initialValues]);const l=(e,t)=>{a((r=>o.handleChange(r,e,t)))},d=e=>{a((t=>o.handleBlur(t,e)))},c=e=>{a((t=>o.handleServerErrors(t,e)))},f=()=>{a(o.buildInitialState(r,e.initialValues))},y=Object.keys(n.fields).reduce(((e,t)=>({...e,[t]:{...n.fields[t],name:t,onBlur:()=>d(t),onChange:e=>l(t,e)}})),{});return u.default.createElement(s,{...e,fields:y,form:{valid:n.valid,touched:n.touched,error:n.error},onFieldChange:l,onFieldBlur:d,onSubmit:async r=>{r&&"function"==typeof r.preventDefault&&r.preventDefault();const i=o.handleSubmit(n);if(a(i),!i.valid)return;!1!==await t(e,o.getData(i),c)&&f()},onReset:f})}),s)};
